import React, {Component} from 'react'
import {
  ArrowUpOutlined,
  ArrowDownOutlined,
  ArrowLeftOutlined,
  ArrowRightOutlined,
  DownOutlined,
  UpOutlined,
  LeftOutlined,
  RightOutlined,
  UploadOutlined,
  DownloadOutlined,
  StepBackwardOutlined,
  StepForwardOutlined,
  DoubleRightOutlined,
  DoubleLeftOutlined,
  ForwardOutlined,
  BackwardOutlined,
  RollbackOutlined,
  EnterOutlined,
  RetweetOutlined,
  SwapOutlined,
  SwapLeftOutlined,
  SwapRightOutlined,
  PlayCircleOutlined,
  LoginOutlined,
  LogoutOutlined,
  FullscreenOutlined,
  FullscreenExitOutlined,
  QuestionOutlined,
  QuestionCircleOutlined,
  PlusOutlined,
  PlusCircleOutlined,
  PauseCircleOutlined,
  MinusOutlined,
  MinusCircleOutlined,
  InfoCircleOutlined,
  ExclamationCircleOutlined,
  CloseOutlined,
  CloseCircleOutlined,
  CheckOutlined,
  CheckCircleOutlined,
  ClockCircleOutlined,
  WarningOutlined,
  StopOutlined,
  EditOutlined,
  FormOutlined,
  CopyOutlined,
  ScissorOutlined,
  DeleteOutlined,
  SnippetsOutlined,
  HighlightOutlined,
  RedoOutlined,
  UndoOutlined,
  ZoomInOutlined,
  ZoomOutOutlined,
  DashOutlined,
  SortAscendingOutlined,
  SortDescendingOutlined,
  AreaChartOutlined,
  PieChartOutlined,
  BarChartOutlined,
  DotChartOutlined,
  LineChartOutlined,
  RadarChartOutlined,
  FallOutlined,
  RiseOutlined,
  StockOutlined,
  AppleOutlined,
  DingdingOutlined,
  WeiboOutlined,
  WechatOutlined,
  TaobaoOutlined,
  QqOutlined,
  AlipayOutlined,
  UserOutlined,
  AccountBookOutlined,
  AlertOutlined,
  ApiOutlined,
  AppstoreOutlined,
  AudioOutlined,
  BankOutlined,
  BellOutlined,
  ScanOutlined,
  BugOutlined,
  CalendarOutlined,
  CameraOutlined,
  CloudOutlined,
  CompassOutlined,
  CreditCardOutlined,
  CustomerServiceOutlined,
  DashboardOutlined,
  EllipsisOutlined,
  MoreOutlined,
  DatabaseOutlined,
  DislikeOutlined,
  EnvironmentOutlined,
  EyeOutlined,
  EyeInvisibleOutlined,
  FileOutlined,
  FilterOutlined,
  FireOutlined,
  FlagOutlined,
  FolderAddOutlined,
  FolderOutlined,
  FolderOpenOutlined,
  HeartOutlined,
  HomeOutlined,
  HourglassOutlined,
  IdcardOutlined,
  LikeOutlined,
  LockOutlined,
  MailOutlined,
  MessageOutlined,
  MobileOutlined,
  PhoneOutlined,
  PictureOutlined,
  RedEnvelopeOutlined,
  SettingOutlined,
  ToolOutlined,
  SmileOutlined,
  StarOutlined,
  ThunderboltOutlined,
  UnlockOutlined,
  BarcodeOutlined,
  KeyOutlined,
  ManOutlined,
  WomanOutlined,
  TeamOutlined,
  PoweroffOutlined,
  SearchOutlined,
  ShoppingCartOutlined,
  LinkOutlined,
  AimOutlined,
  ApartmentOutlined,
  AppstoreAddOutlined,
  AudioMutedOutlined,
  AuditOutlined,
  BarsOutlined,
  BlockOutlined,
  BookOutlined,
  BulbOutlined,
  BorderOutlined,
  NumberOutlined,
  BranchesOutlined,
  BuildOutlined,
  CalculatorOutlined,
  CarOutlined,
  CarryOutOutlined,
  CiOutlined,
  ClearOutlined,
  CloudDownloadOutlined,
  CloudServerOutlined,
  CloudSyncOutlined,
  CloudUploadOutlined,
  ClusterOutlined,
  CodeOutlined,
  CoffeeOutlined,
  CommentOutlined,
  CompressOutlined,
  ControlOutlined,
  CopyrightOutlined,
  CrownOutlined,
  DeleteColumnOutlined,
  DeleteRowOutlined,
  DeliveredProcedureOutlined,
  DeploymentUnitOutlined,
  DesktopOutlined,
  DisconnectOutlined,
  DollarOutlined,
  EuroOutlined,
  ExpandOutlined,
  ExportOutlined,
  FileAddOutlined,
  FileDoneOutlined,
  FileImageOutlined,
  FilePdfOutlined,
  FilePptOutlined,
  FileTextOutlined,
  FileUnknownOutlined,
  FileWordOutlined,
  FileZipOutlined,
  ForkOutlined,
  FrownOutlined,
  FunnelPlotOutlined,
  GatewayOutlined,
  GifOutlined,
  GiftOutlined,
  GlobalOutlined,
  GoldOutlined,
  ImportOutlined,
  LaptopOutlined,
  LoadingOutlined,
  MedicineBoxOutlined,
  MehOutlined,
  MenuOutlined,
  PaperClipOutlined,
  PartitionOutlined,
  PayCircleOutlined,
  PrinterOutlined,
  PushpinOutlined,
  QrcodeOutlined,
  ReloadOutlined,
  RestOutlined,
  RobotOutlined,
  RotateLeftOutlined,
  RotateRightOutlined,
  SafetyCertificateOutlined,
  SaveOutlined,
  SendOutlined,
  ShakeOutlined,
  ShareAltOutlined,
  ShopOutlined,
  ShoppingOutlined,
  SoundOutlined,
  SyncOutlined,
  TagOutlined,
  TagsOutlined,
  TrademarkOutlined,
  TrophyOutlined,
  UsbOutlined,
  UserAddOutlined,
  UserDeleteOutlined,
  UserSwitchOutlined,
  VideoCameraOutlined,
  WifiOutlined,
  TableOutlined
} from '@ant-design/icons'

const MkIcons = {
  'arrow-up': (props) => <ArrowUpOutlined {...props} />,
  'arrow-down': (props) => <ArrowDownOutlined {...props} />,
  'arrow-left': (props) => <ArrowLeftOutlined {...props} />,
  'arrow-right': (props) => <ArrowRightOutlined {...props} />,
  'down': (props) => <DownOutlined {...props} />,
  'up': (props) => <UpOutlined {...props} />,
  'left': (props) => <LeftOutlined {...props} />,
  'right': (props) => <RightOutlined {...props} />,
  'upload': (props) => <UploadOutlined {...props} />,
  'download': (props) => <DownloadOutlined {...props} />,
  'step-backward': (props) => <StepBackwardOutlined {...props} />,
  'step-forward': (props) => <StepForwardOutlined {...props} />,
  'double-right': (props) => <DoubleRightOutlined {...props} />,
  'double-left': (props) => <DoubleLeftOutlined {...props} />,
  'forward': (props) => <ForwardOutlined {...props} />,
  'backward': (props) => <BackwardOutlined {...props} />,
  'rollback': (props) => <RollbackOutlined {...props} />,
  'enter': (props) => <EnterOutlined {...props} />,
  'retweet': (props) => <RetweetOutlined {...props} />,
  'swap': (props) => <SwapOutlined {...props} />,
  'swap-left': (props) => <SwapLeftOutlined {...props} />,
  'swap-right': (props) => <SwapRightOutlined {...props} />,
  'play-circle': (props) => <PlayCircleOutlined {...props} />,
  'login': (props) => <LoginOutlined {...props} />,
  'logout': (props) => <LogoutOutlined {...props} />,
  'fullscreen': (props) => <FullscreenOutlined {...props} />,
  'fullscreen-exit': (props) => <FullscreenExitOutlined {...props} />,
  
  'question': (props) => <QuestionOutlined {...props} />,
  'question-circle': (props) => <QuestionCircleOutlined {...props} />,
  'plus': (props) => <PlusOutlined {...props} />,
  'plus-circle': (props) => <PlusCircleOutlined {...props} />,
  'pause-circle': (props) => <PauseCircleOutlined {...props} />,
  'minus': (props) => <MinusOutlined {...props} />,
  'minus-circle': (props) => <MinusCircleOutlined {...props} />,
  'info-circle': (props) => <InfoCircleOutlined {...props} />,
  'exclamation-circle': (props) => <ExclamationCircleOutlined {...props} />,
  'close': (props) => <CloseOutlined {...props} />,
  'close-circle': (props) => <CloseCircleOutlined {...props} />,
  'check': (props) => <CheckOutlined {...props} />,
  'check-circle': (props) => <CheckCircleOutlined {...props} />,
  'clock-circle': (props) => <ClockCircleOutlined {...props} />,
  'warning': (props) => <WarningOutlined {...props} />,
  'stop': (props) => <StopOutlined {...props} />,

  'edit': (props) => <EditOutlined {...props} />,
  'form': (props) => <FormOutlined {...props} />,
  'copy': (props) => <CopyOutlined {...props} />,
  'scissor': (props) => <ScissorOutlined {...props} />,
  'delete': (props) => <DeleteOutlined {...props} />,
  'snippets': (props) => <SnippetsOutlined {...props} />,
  'highlight': (props) => <HighlightOutlined {...props} />,
  'redo': (props) => <RedoOutlined {...props} />,
  'undo': (props) => <UndoOutlined {...props} />,
  'zoom-in': (props) => <ZoomInOutlined {...props} />,
  'zoom-out': (props) => <ZoomOutOutlined {...props} />,
  'dash': (props) => <DashOutlined {...props} />,
  'sort-ascending': (props) => <SortAscendingOutlined {...props} />,
  'sort-descending': (props) => <SortDescendingOutlined {...props} />,

  'area-chart': (props) => <AreaChartOutlined {...props} />,
  'pie-chart': (props) => <PieChartOutlined {...props} />,
  'bar-chart': (props) => <BarChartOutlined {...props} />,
  'dot-chart': (props) => <DotChartOutlined {...props} />,
  'line-chart': (props) => <LineChartOutlined {...props} />,
  'radar-chart': (props) => <RadarChartOutlined {...props} />,
  'fall': (props) => <FallOutlined {...props} />,
  'rise': (props) => <RiseOutlined {...props} />,
  'stock': (props) => <StockOutlined {...props} />,

  'apple': (props) => <AppleOutlined {...props} />,
  'dingding': (props) => <DingdingOutlined {...props} />,
  'weibo': (props) => <WeiboOutlined {...props} />,
  'wechat': (props) => <WechatOutlined {...props} />,
  'taobao': (props) => <TaobaoOutlined {...props} />,
  'qq': (props) => <QqOutlined {...props} />,
  'alipay': (props) => <AlipayOutlined {...props} />,

  'user': (props) => <UserOutlined {...props} />,
  'account-book': (props) => <AccountBookOutlined {...props} />,
  'alert': (props) => <AlertOutlined {...props} />,
  'api': (props) => <ApiOutlined {...props} />,
  'appstore': (props) => <AppstoreOutlined {...props} />,
  'audio': (props) => <AudioOutlined {...props} />,
  'bank': (props) => <BankOutlined {...props} />,
  'bell': (props) => <BellOutlined {...props} />,
  'scan': (props) => <ScanOutlined {...props} />,
  'bug': (props) => <BugOutlined {...props} />,
  'calendar': (props) => <CalendarOutlined {...props} />,
  'camera': (props) => <CameraOutlined {...props} />,
  'cloud': (props) => <CloudOutlined {...props} />,
  'compass': (props) => <CompassOutlined {...props} />,
  'credit-card': (props) => <CreditCardOutlined {...props} />,
  'customer-service': (props) => <CustomerServiceOutlined {...props} />,
  'dashboard': (props) => <DashboardOutlined {...props} />,
  'ellipsis': (props) => <EllipsisOutlined {...props} />,
  'more': (props) => <MoreOutlined {...props} />,
  'database': (props) => <DatabaseOutlined {...props} />,
  'dislike': (props) => <DislikeOutlined {...props} />,
  'environment': (props) => <EnvironmentOutlined {...props} />,
  'eye-invisible': (props) => <EyeInvisibleOutlined {...props} />,
  'eye': (props) => <EyeOutlined {...props} />,
  'file': (props) => <FileOutlined {...props} />,
  'filter': (props) => <FilterOutlined {...props} />,
  'fire': (props) => <FireOutlined {...props} />,
  'flag': (props) => <FlagOutlined {...props} />,
  'folder-add': (props) => <FolderAddOutlined {...props} />,
  'folder': (props) => <FolderOutlined {...props} />,
  'folder-open': (props) => <FolderOpenOutlined {...props} />,
  'heart': (props) => <HeartOutlined {...props} />,
  'home': (props) => <HomeOutlined {...props} />,
  'hourglass': (props) => <HourglassOutlined {...props} />,
  'idcard': (props) => <IdcardOutlined {...props} />,
  'like': (props) => <LikeOutlined {...props} />,
  'lock': (props) => <LockOutlined {...props} />,
  'mail': (props) => <MailOutlined {...props} />,
  'message': (props) => <MessageOutlined {...props} />,
  'mobile': (props) => <MobileOutlined {...props} />,
  'phone': (props) => <PhoneOutlined {...props} />,
  'picture': (props) => <PictureOutlined {...props} />,
  'red-envelope': (props) => <RedEnvelopeOutlined {...props} />,
  'setting': (props) => <SettingOutlined {...props}/>,
  'tool': (props) => <ToolOutlined {...props} />,
  'smile': (props) => <SmileOutlined {...props} />,
  'star': (props) => <StarOutlined {...props} />,
  'thunderbolt': (props) => <ThunderboltOutlined {...props} />,
  'unlock': (props) => <UnlockOutlined {...props} />,
  'barcode': (props) => <BarcodeOutlined {...props} />,
  'key': (props) => <KeyOutlined {...props} />,
  'man': (props) => <ManOutlined {...props} />,
  'woman': (props) => <WomanOutlined {...props} />,
  'team': (props) => <TeamOutlined {...props} />,
  'poweroff': (props) => <PoweroffOutlined {...props} />,
  'search': (props) => <SearchOutlined {...props} />,
  'shopping-cart': (props) => <ShoppingCartOutlined {...props} />,
  'link': (props) => <LinkOutlined {...props} />,
  'aim': (props) => <AimOutlined {...props} />,
  'apartment': (props) => <ApartmentOutlined {...props} />,
  'appstore-add': (props) => <AppstoreAddOutlined {...props} />,
  'audio-mute': (props) => <AudioMutedOutlined {...props} />,
  'audit': (props) => <AuditOutlined {...props} />,
  'bars': (props) => <BarsOutlined {...props} />,
  'block': (props) => <BlockOutlined {...props} />,
  'book': (props) => <BookOutlined {...props} />,
  'bulb': (props) => <BulbOutlined {...props} />,
  'border': (props) => <BorderOutlined {...props} />,
  'number': (props) => <NumberOutlined {...props} />,
  'branches': (props) => <BranchesOutlined {...props} />,
  'build': (props) => <BuildOutlined {...props} />,
  'calculator': (props) => <CalculatorOutlined {...props} />,
  'car': (props) => <CarOutlined {...props} />,
  'carry-out': (props) => <CarryOutOutlined {...props} />,
  'ci': (props) => <CiOutlined {...props} />,
  'clear': (props) => <ClearOutlined {...props} />,
  'cloud-download': (props) => <CloudDownloadOutlined {...props} />,
  'cloud-server': (props) => <CloudServerOutlined {...props} />,
  'cloud-sync': (props) => <CloudSyncOutlined {...props} />,
  'cloud-upload': (props) => <CloudUploadOutlined {...props} />,
  'cluster': (props) => <ClusterOutlined {...props} />,
  'code': (props) => <CodeOutlined {...props} />,
  'coffee': (props) => <CoffeeOutlined {...props} />,
  'comment': (props) => <CommentOutlined {...props} />,
  'compress': (props) => <CompressOutlined {...props} />,
  'control': (props) => <ControlOutlined {...props} />,
  'copyright': (props) => <CopyrightOutlined {...props} />,
  'crown': (props) => <CrownOutlined {...props} />,
  'delete-column': (props) => <DeleteColumnOutlined {...props} />,
  'delete-row': (props) => <DeleteRowOutlined {...props} />,
  'delivered-procedure': (props) => <DeliveredProcedureOutlined {...props} />,
  'deployment-unit': (props) => <DeploymentUnitOutlined {...props} />,
  'desktop': (props) => <DesktopOutlined {...props} />,
  'disconnect': (props) => <DisconnectOutlined {...props} />,
  'dollar': (props) => <DollarOutlined {...props} />,
  'euro': (props) => <EuroOutlined {...props} />,
  'expand': (props) => <ExpandOutlined {...props} />,
  'export': (props) => <ExportOutlined {...props} />,
  'file-add': (props) => <FileAddOutlined {...props} />,
  'file-done': (props) => <FileDoneOutlined {...props} />,
  'file-image': (props) => <FileImageOutlined {...props} />,
  'file-pdf': (props) => <FilePdfOutlined {...props} />,
  'file-ppt': (props) => <FilePptOutlined {...props} />,
  'file-text': (props) => <FileTextOutlined {...props} />,
  'file-unknown': (props) => <FileUnknownOutlined {...props} />,
  'file-word': (props) => <FileWordOutlined {...props} />,
  'file-zip': (props) => <FileZipOutlined {...props} />,
  'fork': (props) => <ForkOutlined {...props} />,
  'frown': (props) => <FrownOutlined {...props} />,
  'funnel-plot': (props) => <FunnelPlotOutlined {...props} />,
  'gateway': (props) => <GatewayOutlined {...props} />,
  'gif': (props) => <GifOutlined {...props} />,
  'gift': (props) => <GiftOutlined {...props} />,
  'global': (props) => <GlobalOutlined {...props} />,
  'gold': (props) => <GoldOutlined {...props} />,
  'import': (props) => <ImportOutlined {...props} />,
  'laptop': (props) => <LaptopOutlined {...props} />,
  'loading': (props) => <LoadingOutlined {...props} />,
  'medicine-box': (props) => <MedicineBoxOutlined {...props} />,
  'meh': (props) => <MehOutlined {...props} />,
  'menu': (props) => <MenuOutlined {...props} />,
  'paper-clip': (props) => <PaperClipOutlined {...props} />,
  'partition': (props) => <PartitionOutlined {...props} />,
  'pay-circle': (props) => <PayCircleOutlined {...props} />,
  'printer': (props) => <PrinterOutlined {...props} />,
  'pushpin': (props) => <PushpinOutlined {...props} />,
  'qrcode': (props) => <QrcodeOutlined {...props} />,
  'reload': (props) => <ReloadOutlined {...props} />,
  'rest': (props) => <RestOutlined {...props} />,
  'robot': (props) => <RobotOutlined {...props} />,
  'rotate-left': (props) => <RotateLeftOutlined {...props} />,
  'rotate-right': (props) => <RotateRightOutlined {...props} />,
  'safety-certificate': (props) => <SafetyCertificateOutlined {...props} />,
  'save': (props) => <SaveOutlined {...props} />,
  'send': (props) => <SendOutlined {...props} />,
  'shake': (props) => <ShakeOutlined {...props} />,
  'share-alt': (props) => <ShareAltOutlined {...props} />,
  'shop': (props) => <ShopOutlined {...props} />,
  'shopping': (props) => <ShoppingOutlined {...props} />,
  'sound': (props) => <SoundOutlined {...props} />,
  'sync': (props) => <SyncOutlined {...props} />,
  'tag': (props) => <TagOutlined {...props} />,
  'tags': (props) => <TagsOutlined {...props} />,
  'trademark': (props) => <TrademarkOutlined {...props} />,
  'trophy': (props) => <TrophyOutlined {...props} />,
  'usb': (props) => <UsbOutlined {...props} />,
  'user-add': (props) => <UserAddOutlined {...props} />,
  'user-delete': (props) => <UserDeleteOutlined {...props} />,
  'user-switch': (props) => <UserSwitchOutlined {...props} />,
  'video-camera': (props) => <VideoCameraOutlined {...props} />,
  'wifi': (props) => <WifiOutlined {...props} />,
  'table': (props) => <TableOutlined {...props} />,
}

class MkIcon extends Component {
  render() {
    const { type, ...resProps } = this.props

    if (!type) {
      return null
    } else if (MkIcons[type]) {
      return (
        MkIcons[type](resProps)
      )
    } else {
      let svg = type

      if (!/<svg/.test(svg)) {
        try {
          svg = window.decodeURIComponent(window.atob(svg))
          if (!/<svg/.test(svg)) {
            svg = ''
          }
        } catch (e) {
          svg = ''
        }
      }

      return <span className={'anticon anticon-mk ' + (resProps.className || '')} style={resProps.style || null} dangerouslySetInnerHTML={{ __html: svg }}></span>
    }
  }
}
export default MkIcon